
alter session set current_schema = TFG_GPOSESMZ;

/**
************************* Tabla Campaña *************************
*/
alter table CAMPANHA add constraint FK_CAMPANHA_PERSONA_ID foreign key(ID) references PERSONA(ID);

/**
************************* Tabla Auditoría *************************
*/
alter table AUDITORIA add constraint FK_AUDITORIA_CAMPANHA_ID foreign key(IDCAMPANHA) references CAMPANHA(ID);
alter table AUDITORIA add constraint FK_AUDITORIA_EMPRESA_ID foreign key(IDEMPRESA) references EMPRESA(ID);
alter table AUDITORIA add constraint FK_AUDITORIA_EMPRESAEXTERNA_ID foreign key(IDEMPRESAEXTERNA) references EMPRESA_EXTERNA(ID);

/**
************************* Tabla Departamento *************************
*/
alter table DEPARTAMENTO add constraint FK_DEPARTAMENTO_EMPRESA_ID foreign key(IDEMPRESA) references EMPRESA(ID);

/**
************************* Tabla Auditoria Departamento *************************
*/
alter table AUDITORIA_DEPARTAMENTO add constraint FK_AD_AUDITORIA_ID foreign key(IDAUDITORIA) references AUDITORIA(ID);
alter table AUDITORIA_DEPARTAMENTO add constraint FK_AD_DEPARTAMENTO_ID foreign key(IDDEPARTAMENTO) references DEPARTAMENTO(ID);

/**
************************* Tabla Control *************************
*/
alter table CONTROL add constraint FK_CONTROL_AUDITORIA_ID foreign key(IDAUDITORIA) references AUDITORIA(ID);
alter table CONTROL add constraint FK_CONTROL_CREADOR_ID foreign key(IDCREADOR) references PERSONA(ID);
alter table CONTROL add constraint FK_CONTROL_EJECUTOR_ID foreign key(IDEJECUTOR) references PERSONA(ID);
alter table CONTROL add constraint FK_CONTROL_RIESGO_ID foreign key(IDRIESGO) references RIESGO(ID);

/**
************************* Tabla Muestreo *************************
*/
alter table MUESTREO add constraint FK_MUESTREO_CONTROL_ID foreign key(IDCONTROL) references CONTROL(ID);
alter table MUESTREO add constraint FK_MUESTRO_RESPONSABLE_ID foreign key(IDRESPONSABLE) references PERSONA(ID);

/**
************************* Tabla Persona *************************
*/
alter table PERSONA add constraint FK_PERSONA_EMPRESA_ID foreign key(IDEMPRESA) references EMPRESA(ID);
alter table PERSONA add constraint FK_PERSONA_DEPARTAMENTO_ID foreign key(IDDEPARTAMENTO) references DEPARTAMENTO(ID);
alter table PERSONA add constraint FK_PERSONA_ORIGEN_ID foreign key(IDORIGEN) references EQUIPO_ORIGEN(ID);

/**
************************* Tabla Acción *************************
*/
alter table ACCION add constraint FK_ACCION_CREADOR_ID foreign key(IDCREADOR) references PERSONA(ID);
alter table ACCION add constraint FK_ACCION_RESPONSABLE_ID foreign key(IDRESPONSABLE) references PERSONA(ID);
alter table ACCION add constraint FK_ACCION_ESTADO_ID foreign key(IDESTADO) references ESTADO_ACCION(ID);
alter table ACCION add constraint FK_ACCION_RIESGO_ID foreign key(IDRIESGO) references RIESGO(ID);

/**
************************* Tabla Acción estado historico *************************
*/
alter table ACCION_ESTADO_HISTORICO add constraint FK_AEH_ACCION_ID foreign key(IDACCION) references ACCION(ID);
alter table ACCION_ESTADO_HISTORICO add constraint FK_AEH_ESTADO_ACCION_ID foreign key(IDESTADOACTUAL) references ESTADO_ACCION(ID);
alter table ACCION_ESTADO_HISTORICO add constraint FK_AEH_ESTADO_ANT_ACCION_ID foreign key(IDESTADOANTERIOR) references ESTADO_ACCION(ID);

/**
************************* Tabla Categoría *************************
*/
alter table CATEGORIA add constraint FK_CATEGORIA_CREADOR_ID foreign key(IDCREADOR) references PERSONA(ID);
alter table CATEGORIA add constraint FK_CATEGORIA_IMPORTANCIA_ID foreign key(IDIMPORTANCIA) references IMPORTANCIA(ID);

/**
************************* Tabla Riesgo *************************
*/
alter table RIESGO add constraint FK_RIESGO_CATEGORIA_ID foreign key(IDCATEGORIA) references CATEGORIA(ID);
alter table RIESGO add constraint FK_RIESGO_CRITICIDAD_ID foreign key(IDCRITICIDAD) references CRITICIDAD(ID);
alter table RIESGO add constraint FK_RIESGO_ORIGEN_ID foreign key(IDORIGEN) references EQUIPO_ORIGEN(ID);
alter table RIESGO add constraint FK_RIESGO_RESPONSABLE_ID foreign key(IDRESPONSABLE) references PERSONA(ID);
alter table RIESGO add constraint FK_RIESGO_ESTADO_RIESGO_ID foreign key(IDESTADORIESGO) references ESTADO_RIESGO(ID);

/
