
alter session set current_schema = TFG_GPOSESMZ;

/**
************************* Tabla Campaña *************************
*/
CREATE INDEX IDX_CAMPANHA_IDLIDER ON CAMPANHA (IDLIDER) TABLESPACE TBS_TFG_INDICES;

/**
************************* Tabla Auditoría *************************
*/
CREATE INDEX IDX_AUDITORIA_IDCAMPANHA ON AUDITORIA (IDCAMPANHA) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_AUDITORIA_IDEMPRESA ON AUDITORIA (IDEMPRESA) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_AUDITORIA_IDEMPRESAEXTERNA ON AUDITORIA (IDEMPRESAEXTERNA) TABLESPACE TBS_TFG_INDICES;

/**
************************* Tabla Departamento *************************
*/
CREATE INDEX IDX_DEPARTAMENTO_IDEMPRESA ON DEPARTAMENTO (IDEMPRESA) TABLESPACE TBS_TFG_INDICES;

/**
************************* Tabla Auditoria Departamento *************************
*/
CREATE INDEX IDX_AUDITORIA_DEPARTAMENTO_IDAUDITORIA ON AUDITORIA_DEPARTAMENTO (IDAUDITORIA) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_AUDITORIA_DEPARTAMENTO_IDDEPARTAMENTO ON AUDITORIA_DEPARTAMENTO (IDDEPARTAMENTO) TABLESPACE TBS_TFG_INDICES;

/**
************************* Tabla Control *************************
*/
CREATE INDEX IDX_CONTROL_IDAUDITORIA ON CONTROL (IDAUDITORIA) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_CONTROL_IDCREADOR ON CONTROL (IDCREADOR) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_CONTROL_IDEJECUTOR ON CONTROL (IDEJECUTOR) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_CONTROL_IDRIESGO ON CONTROL (IDRIESGO) TABLESPACE TBS_TFG_INDICES;

/**
************************* Tabla Muestreo *************************
*/
CREATE INDEX IDX_MUESTREO_IDCONTROL ON MUESTREO (IDCONTROL) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_MUESTREO_IDRESPONSABLE ON MUESTREO (IDRESPONSABLE) TABLESPACE TBS_TFG_INDICES;

/**
************************* Tabla Persona *************************
*/
CREATE INDEX IDX_PERSONA_IDEMPRESA ON PERSONA (IDEMPRESA) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_PERSONA_IDDEPARTAMENTO ON PERSONA (IDDEPARTAMENTO) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_PERSONA_IDORIGEN ON PERSONA (IDORIGEN) TABLESPACE TBS_TFG_INDICES;

/**
************************* Tabla Acción *************************
*/
CREATE INDEX IDX_ACCION_IDCREADOR ON ACCION (IDCREADOR) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_ACCION_IDRESPONSABLE ON ACCION (IDRESPONSABLE) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_ACCION_IDESTADO ON ACCION (IDESTADO) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_ACCION_IDRIESGO ON ACCION (IDRIESGO) TABLESPACE TBS_TFG_INDICES;

/**
************************* Tabla Acción estado historico *************************
*/
CREATE INDEX IDX_AEH_IDACCION ON ACCION_ESTADO_HISTORICO (IDACCION) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_AEH_IDESTADOACCION ON ACCION_ESTADO_HISTORICO (IDESTADOACTUAL) TABLESPACE TBS_TFG_INDICES;

/**
************************* Tabla Categoría *************************
*/
CREATE INDEX IDX_CATEGORIA_IDCREADOR ON CATEGORIA (IDCREADOR) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_CATEGORIA_IDIMPORTANCIA ON CATEGORIA (IDIMPORTANCIA) TABLESPACE TBS_TFG_INDICES;

/**
************************* Tabla Riesgo *************************
*/
CREATE INDEX IDX_RIESGO_IDCATEGORIA ON RIESGO (IDCATEGORIA) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_RIESGO_IDCRITICIDAD ON RIESGO (IDCRITICIDAD) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_RIESGO_IDORIGEN ON RIESGO (IDORIGEN) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_RIESGO_IDRESPONSABLE ON RIESGO (IDRESPONSABLE) TABLESPACE TBS_TFG_INDICES;
CREATE INDEX IDX_RIESGO_IDESTADORIESGO ON RIESGO (IDESTADORIESGO) TABLESPACE TBS_TFG_INDICES;

/
