
/**
* Inicialización de datos maestros.
*/
ALTER SESSION SET CURRENT_SCHEMA = TFG_GPOSESMZ;

DECLARE
    rsp LOGGER.RSP%TYPE;
	vIdEmpresa NUMBER;
	vIdEmpresaExterna NUMBER;
	vIdDepartamento NUMBER;
	vIdOrigen NUMBER;
	vIdImportancia NUMBER;
	vIdPersona NUMBER;
	vIdPruebas NUMBER;
BEGIN

	INSERT INTO REP_GENERAL VALUES(NULL, NULL, NULL,NULL, NULL, NULL, NULL);	
	
	-- Equipo origen
	PKG_EQUIPO_ORIGEN.altaEquipoOrigen('Auditoria interna', rsp);
	PKG_EQUIPO_ORIGEN.altaEquipoOrigen('Auditoria externa', rsp);
	PKG_EQUIPO_ORIGEN.altaEquipoOrigen('Autoevaluación', rsp);
	
	-- Importancia
	PKG_IMPORTANCIA.altaImportancia('Muy Importante', 1, rsp);
	PKG_IMPORTANCIA.altaImportancia('Importante', 2, rsp);
	PKG_IMPORTANCIA.altaImportancia('Poco Importante', 3, rsp);

	-- Criticidad
	PKG_CRITICIDAD.altaCriticidad('Crítico', 1, rsp);
	PKG_CRITICIDAD.altaCriticidad('Importante', 2, rsp);
	PKG_CRITICIDAD.altaCriticidad('Bajo', 3, rsp);

	-- Estado riesgo
	PKG_ESTADO_RIESGO.altaEstadoRiesgo('Abierto', rsp);
	PKG_ESTADO_RIESGO.altaEstadoRiesgo('Mitigado', rsp);
	PKG_ESTADO_RIESGO.altaEstadoRiesgo('Corregido', rsp);
	
	-- Estado accion
	PKG_ESTADO_ACCION.altaEstadoAccion('Definida', rsp);
	PKG_ESTADO_ACCION.altaEstadoAccion('En curso', rsp);
	PKG_ESTADO_ACCION.altaEstadoAccion('Implementada con el riesgo corregido', rsp);
	PKG_ESTADO_ACCION.altaEstadoAccion('Implementada con el riesgo mitigado', rsp);
	PKG_ESTADO_ACCION.altaEstadoAccion('Descartada', rsp);

	-- Empresa
	PKG_EMPRESA.altaEmpresa('51747611A', 'TFG Company', rsp);
	
	-- EmpresaExterna
	PKG_EMPRESA_EXTERNA.altaEmpresaExterna('72824094E', 'TFG External Company', rsp);
		
	-- Departamento de empresa principal.
	SELECT ID INTO vIdEmpresa FROM EMPRESA WHERE CIF = '51747611A';	
	PKG_DEPARTAMENTO.altaDepartamento('Informática', vIdEmpresa, rsp);
	PKG_DEPARTAMENTO.altaDepartamento('Administración', vIdEmpresa, rsp);
	PKG_DEPARTAMENTO.altaDepartamento('Seguridad', vIdEmpresa, rsp);
	PKG_DEPARTAMENTO.altaDepartamento('Limpieza', vIdEmpresa, rsp);
	
	
	-- Personas del departamento de informatica
		SELECT ID INTO vIdDepartamento FROM DEPARTAMENTO WHERE NOMBRE = 'Informática';
		-- Equipo Interno
		SELECT ID INTO vIdOrigen FROM EQUIPO_ORIGEN WHERE NOMBRE = 'Auditoria interna';
		PKG_PERSONA.altaPersona('45952991A', 'Gonzalo Pose Somoza', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		PKG_PERSONA.altaPersona('51235183S', 'Diana Lodeiro', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		
		-- Equipo Externo
		SELECT ID INTO vIdOrigen FROM EQUIPO_ORIGEN WHERE NOMBRE = 'Auditoria externa';
		PKG_PERSONA.altaPersona('85200946E', 'María Mercedes Santos', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		PKG_PERSONA.altaPersona('63671744Q', 'Emilio Lozano', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		
		-- Equipo Autoevaluación
		SELECT ID INTO vIdOrigen FROM EQUIPO_ORIGEN WHERE NOMBRE = 'Autoevaluación';
		PKG_PERSONA.altaPersona('02231132V', 'Daniel Vazquez', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		PKG_PERSONA.altaPersona('48203962X', 'Verónica Gallardo', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
	
	-- Personas del departamento de administración
		SELECT ID INTO vIdDepartamento FROM DEPARTAMENTO WHERE NOMBRE = 'Administración';
		-- Equipo Interno
		SELECT ID INTO vIdOrigen FROM EQUIPO_ORIGEN WHERE NOMBRE = 'Auditoria interna';
		PKG_PERSONA.altaPersona('24577758G', 'Andrés Vara Mir', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		PKG_PERSONA.altaPersona('23243504A', 'Lalo Márquez', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		
		-- Equipo Externo
		SELECT ID INTO vIdOrigen FROM EQUIPO_ORIGEN WHERE NOMBRE = 'Auditoria externa';
		PKG_PERSONA.altaPersona('70041311D', 'Florentino Chico Aragonés', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		PKG_PERSONA.altaPersona('88272111C', 'Irene Pintor Tormo', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		
		-- Equipo Autoevaluación
		SELECT ID INTO vIdOrigen FROM EQUIPO_ORIGEN WHERE NOMBRE = 'Autoevaluación';
		PKG_PERSONA.altaPersona('98619658M', 'Encarna Ferrándiz Gil', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		PKG_PERSONA.altaPersona('57905460Q', 'Mercedes Moll Esteban', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		
	-- Personas del departamento de seguridad
		SELECT ID INTO vIdDepartamento FROM DEPARTAMENTO WHERE NOMBRE = 'Seguridad';
		-- Equipo Interno
		SELECT ID INTO vIdOrigen FROM EQUIPO_ORIGEN WHERE NOMBRE = 'Auditoria interna';
		PKG_PERSONA.altaPersona('88197006X', 'Ariel Manjón Adán', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		PKG_PERSONA.altaPersona('61967893M', 'Teodora Mate Pozo', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		
		-- Equipo Externo
		SELECT ID INTO vIdOrigen FROM EQUIPO_ORIGEN WHERE NOMBRE = 'Auditoria externa';
		PKG_PERSONA.altaPersona('22464733N', 'Candelario Armengol Arroyo', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		PKG_PERSONA.altaPersona('56946351F', 'Jenaro Ojeda', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		
		-- Equipo Autoevaluación
		SELECT ID INTO vIdOrigen FROM EQUIPO_ORIGEN WHERE NOMBRE = 'Autoevaluación';
		PKG_PERSONA.altaPersona('00890316D', 'Tiburcio Velázquez', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		PKG_PERSONA.altaPersona('50407695K', 'Eleuterio Ramírez', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
	
	-- Personas del departamento de limpieza
		SELECT ID INTO vIdDepartamento FROM DEPARTAMENTO WHERE NOMBRE = 'Limpieza';		
		-- Equipo Externo
		SELECT ID INTO vIdOrigen FROM EQUIPO_ORIGEN WHERE NOMBRE = 'Auditoria externa';
		PKG_PERSONA.altaPersona('62564767Y', 'Elisa Cardona', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
		PKG_PERSONA.altaPersona('60837541B', 'Berto Diaz Carnero', vIdEmpresa, vIdEmpresaExterna, vIdDepartamento, vIdOrigen,  rsp);
	
	-- Categorias
		--Creador:
		SELECT ID INTO vIdPersona FROM PERSONA WHERE NIF = '45952991A';
		
		-- Muy Importantes
		SELECT ID INTO vIdImportancia FROM IMPORTANCIA WHERE NOMBRE = 'Muy Importante';
		PKG_CATEGORIA.altaCategoria('Ciberseguridad', vIdPersona, vIdImportancia, rsp);		
		PKG_CATEGORIA.altaCategoria('Aplicaciones informáticas', vIdPersona, vIdImportancia, rsp);
		
		-- Importantes
		SELECT ID INTO vIdImportancia FROM IMPORTANCIA WHERE NOMBRE = 'Importante';
		PKG_CATEGORIA.altaCategoria('Finanzas', vIdPersona, vIdImportancia, rsp);
		
		-- Poco Importantes
		SELECT ID INTO vIdImportancia FROM IMPORTANCIA WHERE NOMBRE = 'Poco Importante';
		PKG_CATEGORIA.altaCategoria('Seguridad física de las instalaciones', vIdPersona, vIdImportancia, rsp);
	
END;

/
