/**
* Pruebas de procedimientos almacenados
*/
ALTER SESSION SET CURRENT_SCHEMA = TFG_GPOSESMZ;
set SERVEROUTPUT on;

DECLARE
    rsp LOGGER.RSP%TYPE;
	vIdAux NUMBER;
	vIdEmpresaAux NUMBER;
	vIdEmpresaExternaAux NUMBER;
	vIdDepartamentoAux NUMBER;
	vIdOrigenAux NUMBER;
    vIdPersonaAux NUMBER;
    vIdImportanciaAux NUMBER;
	vIdCampanaAux NUMBER;
	vIdCategoriaAux NUMBER;
	vIdCriticidadAux NUMBER;
	vIdAuditoriaAux NUMBER;
	vIdControlAux NUMBER;
	vIdEstadoRiesgoAux NUMBER;
	vIdEstadoAccionAux NUMBER;
	vIdRiesgoAux NUMBER;
BEGIN

    -- Recuperación de datos maestros
    BEGIN	
        SELECT ID INTO vIdEmpresaAux FROM EMPRESA WHERE CIF = '51747611A';
        SELECT ID INTO vIdEmpresaExternaAux FROM EMPRESA_EXTERNA WHERE CIF = '72824094E';
        SELECT ID INTO vIdDepartamentoAux FROM DEPARTAMENTO WHERE NOMBRE = 'Informática';
        SELECT ID INTO vIdOrigenAux FROM EQUIPO_ORIGEN WHERE NOMBRE = 'Auditoria interna';
        SELECT ID INTO vIdPersonaAux FROM PERSONA WHERE NIF = '45952991A';
        SELECT ID INTO vIdImportanciaAux FROM IMPORTANCIA WHERE NOMBRE = 'Muy Importante';
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en la recuperacion de datos maestros. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
    
	--Pruebas	
	-- Valores nulos.
	BEGIN
		PKG_EQUIPO_ORIGEN.altaEquipoOrigen(null, rsp);
		PKG_IMPORTANCIA.altaImportancia(NULL, 4, rsp);
		PKG_CRITICIDAD.altaCriticidad(NULL, 4, rsp);
		PKG_ESTADO_RIESGO.altaEstadoRiesgo(NULL, rsp);
		PKG_ESTADO_ACCION.altaEstadoAccion(NULL, rsp);
        PKG_EMPRESA.altaEmpresa(NULL, NULL, rsp);
        PKG_EMPRESA_EXTERNA.altaEmpresaExterna(NULL, NULL, rsp);
        PKG_DEPARTAMENTO.altaDepartamento(NULL, vIdEmpresaAux, rsp);
        PKG_PERSONA.altaPersona(NULL, NULL, vIdEmpresaAux, null, vIdDepartamentoAux, vIdOrigenAux,  rsp);
        PKG_CATEGORIA.altaCategoria(NULL, vIdPersonaAux, vIdImportanciaAux, rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de alta comunes. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
	-------- Equipo origen
    BEGIN
        PKG_EQUIPO_ORIGEN.altaEquipoOrigen('TGF_PR_EQUIPO_Alta', rsp);
        
        SELECT ID INTO vIdAux FROM EQUIPO_ORIGEN WHERE NOMBRE = 'TGF_PR_EQUIPO_Alta';	
        PKG_EQUIPO_ORIGEN.actualizaEquipoOrigen(vIdAux, 'TGF_PR_EQUIPO_Actualizado', rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de EQUIPO_ORIGEN. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
    
	-------- Importancia
    BEGIN
        PKG_IMPORTANCIA.altaImportancia('TGF_PR_IMPORTANCIA_Alta', 4, rsp);
        
        SELECT ID INTO vIdAux FROM IMPORTANCIA WHERE NOMBRE = 'TGF_PR_IMPORTANCIA_Alta';
        PKG_IMPORTANCIA.actualizaImportancia(vIdAux, 'TGF_PR_IMPORTANCIA_Actualizado', 2, rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de IMPORTANCIA. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
	-------- Criticidad
    BEGIN
        PKG_CRITICIDAD.altaCriticidad('TGF_PR_Criticidad_Alta', 4, rsp);
        
        SELECT ID INTO vIdAux FROM CRITICIDAD WHERE NOMBRE = 'TGF_PR_Criticidad_Alta';
        PKG_CRITICIDAD.actualizaCriticidad(vIdAux, 'TGF_PR_Criticidad_Actualizado', 4, rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de CRITICIDAD. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
	-------- Estado riesgo
    BEGIN
        PKG_ESTADO_RIESGO.altaEstadoRiesgo('TGF_PR_EstadoRiesgo_Alta', rsp);
        
        SELECT ID INTO vIdAux FROM ESTADO_RIESGO WHERE NOMBRE = 'TGF_PR_EstadoRiesgo_Alta';
        PKG_ESTADO_RIESGO.actualizaEstadoRiesgo(vIdAux, 'TGF_PR_EstadoRiesgo_Actualizado', rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de ESTADO_RIESGO. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
		
	-------- Estado acción
    BEGIN
        PKG_ESTADO_ACCION.altaEstadoAccion('TGF_PR_EstadoAccion_Alta', rsp);
        
        SELECT ID INTO vIdAux FROM ESTADO_ACCION WHERE NOMBRE = 'TGF_PR_EstadoAccion_Alta';
        PKG_ESTADO_ACCION.actualizaEstadoAccion(vIdAux, 'TGF_PR_EstadoAccion_Actualizado', rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de ESTADO_ACCION. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
	-------- Empresa
    BEGIN
        PKG_EMPRESA.altaEmpresa('CIF_EMPRESA_Alta', 'TGF_PR_EMPRESA_Alta', rsp);
        
        SELECT ID INTO vIdAux FROM EMPRESA WHERE CIF = 'CIF_EMPRESA_Alta';
        PKG_EMPRESA.actualizaEmpresa(vIdAux, 'CIF_EMPRESA_Actualiza', 'TGF_PR_EMPRESA_Actualizada', rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de EMPRESA. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
	-------- Empresa externa
    BEGIN
        PKG_EMPRESA_EXTERNA.altaEmpresaExterna('CIF_EMPRESA_EXTERNA_Alta', 'TGF_PR_EMPRESA_EXTERNA_Alta', rsp);
        
        SELECT ID INTO vIdAux FROM EMPRESA_EXTERNA WHERE CIF = 'CIF_EMPRESA_EXTERNA_Alta';
        PKG_EMPRESA_EXTERNA.actualizaEmpresaExterna(vIdAux, 'CIF_EMPRESA_EXTERNA_Actualiza', 'TGF_PR_EMPRESA_EXTERNA_Actualizada', rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de EMPRESA_EXTERNA. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
    
	-------- Departamento
    BEGIN
        PKG_DEPARTAMENTO.altaDepartamento('TGF_PR_Departamento_Alta', vIdEmpresaAux, rsp);
        
        SELECT ID INTO vIdAux FROM DEPARTAMENTO WHERE NOMBRE = 'TGF_PR_Departamento_Alta';
        PKG_DEPARTAMENTO.actualizaDepartamento(vIdAux, 'TGF_PR_Departamento_Actualizado', vIdEmpresaAux, rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de DEPARTAMENTO. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
	-------- Persona
    BEGIN
        PKG_PERSONA.altaPersona('63465523J', 'TGF_PR_Persona_Alta', vIdEmpresaAux, null, vIdDepartamentoAux, vIdOrigenAux,  rsp);
        
        SELECT ID INTO vIdAux FROM PERSONA WHERE NIF = '63465523J';
        PKG_PERSONA.actualizaPersona(vIdAux, '63465523J', 'TGF_PR_Persona_Actualizada', vIdEmpresaAux, null, vIdDepartamentoAux, vIdOrigenAux,  rsp);
        		
		PKG_PERSONA.altaPersona('63465523J', 'TGF_PR_Persona_Alta', vIdEmpresaAux, vIdEmpresaExternaAux, vIdDepartamentoAux, vIdOrigenAux,  rsp);
		
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de PERSONA. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
	-------- Categoria
    BEGIN
        PKG_CATEGORIA.altaCategoria('TGF_PR_Categoria_Alta', vIdPersonaAux, vIdImportanciaAux, rsp);
        
        SELECT ID INTO vIdAux FROM CATEGORIA WHERE NOMBRE = 'TGF_PR_Categoria_Alta';
        PKG_CATEGORIA.actualizaCategoria(vIdAux, 'TGF_PR_Categoria_Actualizada', vIdPersonaAux, vIdImportanciaAux, rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de CATEGORIA. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
	-------- Campaña
    BEGIN
		SELECT ID INTO vIdPersonaAux FROM PERSONA WHERE NIF = '45952991A';
        
		PKG_CAMPANHA.altaCampanha('TGF_PR_Campaña_Alta', SYSDATE, SYSDATE+30d, vIdPersonaAux, rsp);
        
        SELECT ID INTO vIdAux FROM CAMPANHA WHERE NOMBRE = 'TGF_PR_Campaña_Alta';
        PKG_CAMPANHA.actualizaCampanha(vIdAux, 'TGF_PR_Campaña_Actualizada', SYSDATE, SYSDATE+30d, vIdPersonaAux, rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de CAMPANHA. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
	-------- Auditoria
    BEGIN
		SELECT ID INTO vIdPersonaAux FROM PERSONA WHERE NIF = '45952991A';
        
		SELECT ID INTO vIdCampanaAux FROM CAMPANHA WHERE NOMBRE = 'TGF_PR_Campaña_Actualizada';
		SELECT ID INTO vIdEmpresaAux FROM EMPRESA WHERE CIF = '51747611A';
        SELECT ID INTO vIdEmpresaExternaAux FROM EMPRESA_EXTERNA WHERE CIF = '72824094E';
		
		PKG_AUDITORIA.altaAuditoria('TGF_PR_Auditoria_Alta', 0, vIdCampanaAux, vIdEmpresaAux, vIdEmpresaExternaAux, SYSDATE, rsp);
		
        SELECT ID INTO vIdAux FROM AUDITORIA WHERE DESCRIPCION = 'TGF_PR_Auditoria_Alta';
        PKG_AUDITORIA.actualizaAuditoria(vIdAux, 'TGF_PR_Auditoria_Actualizada', 0, vIdCampanaAux, vIdEmpresaAux, vIdEmpresaExternaAux, SYSDATE, rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de AUDITORIA. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
	-------- Control
    BEGIN
		
		SELECT ID INTO vIdAuditoriaAux FROM AUDITORIA WHERE DESCRIPCION = 'TGF_PR_Auditoria_Actualizada';	
		SELECT ID INTO vIdPersonaAux FROM PERSONA WHERE NIF = '45952991A';        
		
		PKG_CONTROL.altaControl('TGF_PR_Control_Alta', vIdAuditoriaAux, vIdPersonaAux, vIdPersonaAux, null, rsp);
		
        SELECT ID INTO vIdAux FROM CONTROL WHERE DESCRIPCION = 'TGF_PR_Control_Alta';
        PKG_CONTROL.actualizaControl(vIdAux, 'TGF_PR_Control_Actualizado', vIdAuditoriaAux, vIdPersonaAux, vIdPersonaAux, null, rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de CONTROL. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
	-------- Muestreo
    BEGIN
		
		SELECT ID INTO vIdControlAux FROM CONTROL WHERE DESCRIPCION = 'TGF_PR_Control_Actualizado';	
		SELECT ID INTO vIdPersonaAux FROM PERSONA WHERE NIF = '45952991A';        
		
		PKG_MUESTREO.altaMuestreo('TGF_PR_MUESTREO_Alta', 'NO_EJECUTADO', 'Muestreo de prueba.', vIdControlAux, vIdPersonaAux,rsp);
		
        SELECT ID INTO vIdAux FROM MUESTREO WHERE DESCRIPCION = 'TGF_PR_MUESTREO_Alta';
        PKG_MUESTREO.actualizaMuestreo(vIdAux, 'TGF_PR_MUESTREO_Actualizado', 'NO_EJECUTADO', 'Muestreo de prueba.', vIdControlAux, vIdPersonaAux,rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de MUESTREO. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
	-------- Riesgo
    BEGIN
		
		SELECT ID INTO vIdCategoriaAux FROM CATEGORIA WHERE NOMBRE = 'Ciberseguridad';
		SELECT ID INTO vIdCriticidadAux FROM CRITICIDAD WHERE NOMBRE = 'Crítico';
		SELECT ID INTO vIdOrigenAux FROM EQUIPO_ORIGEN WHERE NOMBRE = 'Auditoria interna';
		SELECT ID INTO vIdPersonaAux FROM PERSONA WHERE NIF = '45952991A';
		SELECT ID INTO vIdEstadoRiesgoAux FROM ESTADO_RIESGO WHERE NOMBRE = 'Abierto';
		
		PKG_RIESGO.altaRiesgo('TGF_PR_Riesgo_Alta', vIdCategoriaAux, vIdCriticidadAux, vIdOrigenAux, vIdPersonaAux, vIdEstadoRiesgoAux, rsp);
		
        SELECT ID INTO vIdAux FROM RIESGO WHERE DESCRIPCION = 'TGF_PR_Riesgo_Alta';
        PKG_RIESGO.actualizaRiesgo(vIdAux, 'TGF_PR_Riesgo_actualizado', vIdCategoriaAux, vIdCriticidadAux, vIdOrigenAux, vIdPersonaAux, vIdEstadoRiesgoAux, rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de RIESGO. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
	-------- Acción
    BEGIN		
		SELECT ID INTO vIdPersonaAux FROM PERSONA WHERE NIF = '45952991A';
		SELECT ID INTO vIdEstadoAccionAux FROM ESTADO_ACCION WHERE NOMBRE = 'Definida';
		SELECT ID INTO vIdRiesgoAux FROM RIESGO WHERE DESCRIPCION = 'TGF_PR_Riesgo_actualizado';
		
		PKG_ACCION.altaAccion('TGF_PR_Accion_Alta', SYSDATE+5D, SYSDATE+20D, vIdPersonaAux, vIdPersonaAux, vIdEstadoAccionAux, vIdRiesgoAux, rsp);
		
        SELECT ID INTO vIdAux FROM ACCION WHERE DESCRIPCION = 'TGF_PR_Accion_Alta';
        PKG_ACCION.actualizaAccion(vIdAux, 'TGF_PR_Accion_Actualizada', SYSDATE+5D, SYSDATE+20D, vIdPersonaAux, vIdPersonaAux, vIdEstadoAccionAux, vIdRiesgoAux, rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de ACCION. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
	-------- Auditoria departamento
    BEGIN		
		SELECT ID INTO vIdAuditoriaAux FROM AUDITORIA WHERE DESCRIPCION = 'TGF_PR_Auditoria_Actualizada';	
		SELECT ID INTO vIdDepartamentoAux FROM DEPARTAMENTO WHERE NOMBRE = 'Informática';
		
		PKG_AUDITORIA_DEPARTAMENTO.asignaAuditoriaDepartamento(vIdAuditoriaAux, vIdDepartamentoAux, rsp);
		
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de ACCION. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;

	

	-- Valores nulos en actualizaciones.
	BEGIN
		PKG_EQUIPO_ORIGEN.actualizaEquipoOrigen(999999, null, rsp);
		PKG_IMPORTANCIA.actualizaImportancia(999999, null, 4, rsp);
		PKG_CRITICIDAD.actualizaCriticidad(999999, null, 4, rsp);
		PKG_ESTADO_RIESGO.actualizaEstadoRiesgo(999999, null, rsp);
		PKG_ESTADO_ACCION.actualizaEstadoAccion(999999, null, rsp);
		PKG_EMPRESA.actualizaEmpresa(999999, null, NULL, rsp);
		PKG_EMPRESA_EXTERNA.actualizaEmpresaExterna(999999, null, NULL, rsp);
		PKG_DEPARTAMENTO.actualizaDepartamento(999999, null, vIdEmpresaAux, rsp);
		PKG_PERSONA.actualizaPersona(999999, null, NULL, vIdEmpresaAux, null, vIdDepartamentoAux, vIdOrigenAux,  rsp);
		PKG_CATEGORIA.actualizaCategoria(999999, null, vIdPersonaAux, vIdImportanciaAux, rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de actualizaciones comunes. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;

	BEGIN
		PKG_PERSONA.actualizaPersona(1, '63465523J', 'TGF_PR_Persona_Actualizada', 9999999, null, 9999999, 9999999,  rsp);
        
        EXCEPTION
            WHEN OTHERS THEN
                DBMS_OUTPUT.PUT_LINE('Error en las pruebas de actualizaciones comunes. Claves foráneas. Código error: ' || SQLCODE || ' Mensaje de error: ' || SQLERRM);
    END;
	
END;
/